import React from 'react';
import * as BS from 'react-bootstrap';
import $ from 'jquery';
import _ from 'lodash';
import Multiselect from 'react-bootstrap-multiselect';

import MilestoneBox from './components/MilestoneBox';


class AcceptanceTestingPresets extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      data: [],
      selectedMilestone: [],
    };
    this.handleAddMilestone = this.handleAddMilestone.bind(this);
    this.getAcceptanceData = this.getAcceptanceData.bind(this);
    this.handleMilestoneSelection = this.handleMilestoneSelection.bind(this);
  }

  componentDidMount() {
    $.get('/api/v1.0/testrail/acceptance_runs')
      .done(this.getAcceptanceData);
  }

  getAcceptanceData(data) {
    this.setState({ data });
  }

  handleAddMilestone() {
    const milestones = this.state.data;
    const milestoneId = this.state.selectedMilestone[0];
    let mId = null;
    if (milestoneId.indexOf('_') > -1) {
      mId = milestoneId;
    } else {
      mId = parseInt(milestoneId, 10);
    }
    const mIndex = _.findIndex(milestones, obj => obj.milestone_id === mId);
    if (mIndex === -1) {
      this.setState({ data: [...milestones, { milestone_id: mId, runs: [] }] });
    }
  }

  handleMilestoneSelection() {
    const selectedMilestone = [];
    this.milestonesSelector.$multiselect.find(':selected').each((i, elem) => {
      selectedMilestone.push($(elem).val());
    });
    this.setState({ selectedMilestone });
  }

  renderMilestoneBoxes() {
    return this.state.data.map((milestone) => {
      const milestoneName = mId =>
        window.commonStore.testrail_milestones.filter(obj => obj.id === mId)[0].name;

      return (
        <BS.Panel
          header={milestoneName(milestone.milestone_id)}
          key={milestone.milestone_id}
          eventKey={milestone.milestone_id}
          bsStyle="success"
        >
          <MilestoneBox data={milestone} />
        </BS.Panel>
      );
    });
  }

  render() {
    const trMilestone = window.commonStore.testrail_milestones.map(m => ({
      value: m.id,
      label: m.name,
      selected: _.includes(this.state.selectedMilestone, `${m.id}`),
    }));

    const milestonesSelect = (
      <Multiselect
        id={'testrail_milestone'}
        key="milestone.select"
        ref={(c) => { this.milestonesSelector = c; }}
        buttonWidth="250px"
        maxHeight={400}
        enableFiltering
        nonSelectedText="select milestone"
        allSelectedText="all selected"
        onDropdownHide={this.handleMilestoneSelection}
        data={trMilestone}
      />
      );
    return (
      <div style={{ width: '60%' }}>
        {milestonesSelect}
        <BS.Button bsStyle="success" onClick={this.handleAddMilestone}>Add Milestone</BS.Button>
        <BS.Accordion>
          {this.renderMilestoneBoxes()}
        </BS.Accordion>
      </div>
    );
  }
}


export default AcceptanceTestingPresets;
