import React from 'react';
import * as BS from 'react-bootstrap';
import FeatureTestingPresets from './FeatureTestingPresets';
import DefaultProductVersion from './DefaultProductVersion';
import AcceptanceTestingPresets from './AcceptanceTestingPresets';
import JiraBugFilters from './JiraBugFilters';


export default class AdminArea extends React.Component {

  render() {
    return (
      <div>
        <BS.Panel header={<h4>Default product version</h4>}>
          <DefaultProductVersion />
        </BS.Panel>
        <BS.Panel header={<h4>Presets for Feature Testing Report</h4>}>
          <FeatureTestingPresets />
        </BS.Panel>
        <BS.Panel header={<h4>Presets for Acceptance Testing Report</h4>}>
          <AcceptanceTestingPresets />
        </BS.Panel>
        <BS.Panel header={<h4>Presets for Jira Bugs</h4>}>
          <JiraBugFilters />
        </BS.Panel>
      </div>
    );
  }
}
