import React, { Component } from 'react';
import * as BS from 'react-bootstrap';
import _ from 'lodash';

import SimpleFilterRow from './components/SimpleFilterRow';

const style = {
  width: '40%',
};


export default class JiraBugFilters extends Component {
  constructor(props) {
    super(props);
    this.handleAddRow = this.handleAddRow.bind(this);
    this.handleDelRow = this.handleDelRow.bind(this);
    this.onSaveFilter = this.onSaveFilter.bind(this);
    this.state = {
      filters: window.commonStore.jira_bugs_filter_ids,
    };
  }

  handleAddRow(e) {
    const id = (+new Date() + Math.floor(Math.random() * 932999)).toString(36);
    const _filter = {
      name: '',
      id,
    };
    this.state.filters.push(_filter);
    this.setState(this.state.filters);
  }

  handleDelRow(_filter) {
    $.ajax({
      url: '/admin/_remove_bug_filter',
      dataType: 'json',
      type: 'POST',
      data: _filter,
      success: function(data) {
        this.setState({ filters: data });
      }.bind(this),
      error: function(xhr, status, err) {
        console.error(status, err.toString());
      }.bind(this),
    });
  }

  onSaveFilter(_filter) {
    $.ajax({
      url: '/admin/_save_bug_filter',
      dataType: 'json',
      type: 'POST',
      data: _filter,
      success: function(data) {
        this.setState({ filters: data });
      }.bind(this),
      error: function(xhr, status, err) {
        console.error(status, err.toString());
      }.bind(this),
    });
  }

  render() {
    const { filters } = this.state;

    return (
      <div style={style}>
        <table className="table table-condensed">
          <tbody>
            {_(filters).sortBy('position').map((_filter, i) =>
              (
                <SimpleFilterRow
                  key={_filter.id}
                  id={_filter.id}
                  index={i}
                  link={_filter.id}
                  name={_filter.name}
                  position={_filter.position}
                  onDelEvent={this.handleDelRow}
                  onSaveFilter={this.onSaveFilter}
                />
              )
            ).value()}
          </tbody>
        </table>
        <BS.Button className="btn btn-raised btn-success" onClick={this.handleAddRow}>
          Add
        </BS.Button>
      </div>
    );
  }
 }
