import React from 'react';
import { FormGroup, FormControl, InputGroup } from 'react-bootstrap';
import DateRangePicker from 'react-bootstrap-daterangepicker';
import moment from 'moment';


export default class DatePicker extends React.Component {

  static propTypes = {
    onChange: React.PropTypes.func,
  };

  constructor(props) {
    super(props);
    this.state = {
      startDate: this.props.startDate,
    };
    this.handleEvent = this.handleEvent.bind(this);
  }


  componentWillReceiveProps(nextProps) {
    const upd = {};
    if (nextProps.startDate) {
      upd.startDate = moment(nextProps.startDate);
    }
    this.setState(upd);
  }

  handleEvent(event, picker) {
    const startDate = moment(picker.startDate);
    if (startDate.isSame(this.state.startDate)) {
      return;
    }

    this.setState({
      startDate,
    });

    if (this.props.teamId) {
      this.props.onChange(moment(startDate), this.props.teamId);
    } else {
      this.props.onChange(moment(startDate))
    }
  }

  render() {
    const start = this.state.startDate.format('YYYY-MM-DD');

    return (
      <DateRangePicker
        style={this.props.style}
        className="btn-group simple-range-picker"
        opens="center"
        startDate={moment(start)}
        onApply={this.handleEvent}
        singleDatePicker
        showDropdowns
      >
        <FormGroup>
          <InputGroup>
            {this.props.label ? <InputGroup.Addon><span>{this.props.label}</span></InputGroup.Addon> : null}
            <FormControl type="text" value={start} onChange={() => {}} />
            <InputGroup.Addon><i className="fa fa-calendar" /></InputGroup.Addon>
          </InputGroup>
        </FormGroup>
      </DateRangePicker>
    );
  }

}
