import React, { Component, PropTypes } from 'react';

import TextInput from './TextInput';

const style = {
  fontSize: '25px',
};

export default class SimpleFilterRow extends Component {
  static propTypes = {
    index: PropTypes.number.isRequired,
    name: PropTypes.string.isRequired,
  };

  constructor(props) {
    super(props);
    this.state = {
      filter_name: '',
      filter_link: '',
    };
    this.onDelEvent = this.onDelEvent.bind(this);
    this.onSaveFilter = this.onSaveFilter.bind(this);
  }

  onDelEvent() {
    this.props.onDelEvent({ name: this.props.name, id: this.props.link });
  }

  onSaveFilter() {
    this.props.onSaveFilter({ name: this.iFilterName.value, id: this.iFilterId.value });
  }

  render() {
    const { name } = this.props;
    const isName = name === '' ? false : true;

    return (
      <tr style={{ ...style }}>
        <td style={{ verticalAlign: 'middle' }} className="col-md-3 active">
          <form>
            <TextInput
              iref={(input) => { this.iFilterName = input; }}
              defaultValue={name || 'Input filter name'}
            />
          </form>
        </td>
        <td style={{ verticalAlign: 'middle' }} className="col-md-3 active">
          <form>
            <TextInput
              iref={(input) => { this.iFilterId = input; }}
              defaultValue={isName ? this.props.link : 'Input filter id'}
            />
          </form>
        </td>
        <td style={{ verticalAlign: 'middle' }} className="col-md-3 active">
          <a onClick={this.onSaveFilter} className="btn btn-sm btn-default">
            <i className="fa fa-floppy-o fa-2x" />
          </a>
        </td>
        <td style={{ verticalAlign: 'middle' }} className="col-md-3 active">
          <a onClick={this.onDelEvent} className="btn btn-sm btn-danger">
            <i className="fa fa-times fa-2x" />
          </a>
        </td>
      </tr>
    );
  }
}
