import React, { Component, PropTypes } from 'react';

const propTypes = {
  defaultValue: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired,
  iref: PropTypes.func.isRequired,
};

class TextInput extends Component {

  constructor(props) {
    super(props);
    this.state = { value: '' };

    this.handleChange = this.handleChange.bind(this);
  }

  componentWillMount() {
    this.onChange(this.props.defaultValue);
  }

  onChange(value) {
    this.setState({ value });
  }

  handleChange(event) {
    this.setState({ value: event.target.value });
  }

  render() {
    return (
      <input
        type="text"
        ref={this.props.iref}
        value={this.state.value}
        onChange={this.handleChange}
      />
    );
  }
}

TextInput.propTypes = propTypes;

export default TextInput;
