/**
 * Created by farhad on 17.02.16.
 */
import React from 'react';
import NavBar from './NavBar';


export default class App extends React.Component {

  static propTypes = {
    children: React.PropTypes.node,
  };

  constructor(props) {
    super(props);
    this.state = { commonStore: null };
  }

  componentDidMount() {
    this.fetchInitialData();
  }

  fetchInitialData() {
    // TODO: replace with redux store
    const commonStore = {
      qa_teams: {
        'fuel': 'Fuel QA',
        'mosqa': 'MOS QA',
        'fuel-telco': 'Telco QA',
        'pce': 'PCE QA',
        'performance': 'Performance QA',
        'maintenance': 'Maintenance QA',
        'framework': 'Framework QA',
        'ci-bot': 'CI-bot',
        'unknown': 'Unknown',
      },
      launchpad_teams: [
        'MOS OpenStack',
        'Fuel',
        'Maintenance',
        'Plugins',
        'Docs',
        'PCE',
        'Infra',
        'QA',
        'Unknown',
      ],
      testrail_milestones: null,
      launchpad_milestones: null,
      testrail_qa_teams: null,
      tr_milestone_in_focus: null,
      lp_milestone_in_focus: null,
      jira_filter_ids: null,
      testrail_run_types: null,
      dashboard_in_focus: null,
      jira_fix_versions: null,
      jira_bugs_filter_ids: null,
      testrail_projects: null,
      getTestRailQATeamName(team_id) {
        if (this.testrailQATeamsMap == undefined) {
          this.testrailQATeamsMap = _(this.testrail_qa_teams).groupBy('id').mapValues('0').value();
        }
        return _.get(this.testrailQATeamsMap, [team_id, 'name']);
      },
    };

    function load(url, key) {
      return fetch(url, { credentials: 'same-origin' })
        .then(response => response.json())
        .then(data => ({ [key]: data }));
    }

    Promise.all([
      load('/api/v1.0/testrail/milestones', 'testrail_milestones'),
      load('/api/v1.0/testrail/priorities', 'testrail_priorities'),
      load('/api/v1.0/testrail/qa_teams', 'testrail_qa_teams'),
      load('/api/v1.0/lp/milestones', 'launchpad_milestones'),
      load('/api/v1.0/lp/lp_milestone_in_focus', 'lp_milestone_in_focus'),
      load('/api/v1.0/testrail/tr_milestone_in_focus', 'tr_milestone_in_focus'),
      load('/api/v1.0/jira/filter_ids', 'jira_filter_ids'),
      load('/api/v1.0/testrail/run_types', 'testrail_run_types'),
      load('/api/v1.0/dashboard', 'dashboard_in_focus'),
      load('/api/v1.0/jira/fix_versions', 'jira_fix_versions'),
      load('/api/v1.0/jira/bug_filter_ids', 'jira_bugs_filter_ids'),
      load('/api/v1.0/testrail/projects', 'testrail_projects'),
    ]).then((values) => {
      Object.assign(commonStore, ...values);
      window.commonStore = commonStore;
      setTimeout(() => {
        this.setState({ commonStore });
      }, 0);
    }).catch((error) => {
      console.error(error);
    });
  }

  renderSpinner() {
    return (
      <div style={{ textAlign: 'center', marginTop: '40%' }}>
          <i className="fa fa-spinner fa-pulse fa-5x" />
      </div>
    );
  }

  render() {
    return (
      <div>

        <NavBar />

        <div className="container-fluid content-container">
          {this.state.commonStore ? this.props.children : this.renderSpinner()}
        </div>

        <footer className="footer">
          <div>
            <i className="fa fa-slack" /> #qa-reporting &nbsp;&nbsp;
            <i className="fa fa-envelope" />{" "}
            <a href="mailto:rsalin@mirantis.com">qa-reporting@mirantis.com</a>
          </div>
        </footer>
      </div>
    );
  }
}
