/**
 * Created by farhad on 29.02.16.
 */
import React from 'react';
import classNames from 'classnames';
import { Checkbox, FormGroup } from 'react-bootstrap';


export default class CheckBox extends React.Component {

  static propTypes = {
    togglebutton: React.PropTypes.bool,
    groupClassName: React.PropTypes.string,
    label: React.PropTypes.string,
  };

  static defaultProps = {
    togglebutton: false,
  };

  componentDidMount() {
    if ($.material) {
      if (this.props.togglebutton) {
        $.material.togglebutton(this.input);
      } else {
        $.material.checkbox(this.input);
      }
    }
  }

  render() {
    const { togglebutton, groupClassName, label, ...restProps } = this.props;
    return (
      <FormGroup bsClass={classNames(groupClassName, { togglebutton })}>
        <Checkbox {...restProps} inputRef={(c) => { this.input = c; }}>
          {label}
        </Checkbox>
      </FormGroup>
    );
  }
}
