/**
 * Created by farhad on 20.02.16.
 */
import React from 'react';
import NavLink from './NavLink';

const USER_INFO_URL = '/api/v1.0/auth/user';

export default class NavBar extends React.Component {
  constructor(props) {
    super(props);

    this.state = {
      email: null,
    };
  }

  componentDidMount() {
    this.loadUserInfo();
  }

  loadUserInfo() {
    return $.get(USER_INFO_URL)
      .done((info) => {
        this.setState({ email: info.email });
      });
  }

  render() {
    return (
      <div className="navbar navbar-default navbar-fixed-top">
        <div className="container-fluid">

          <div className="navbar-header">
            <NavLink className="navbar-brand" to="/"> QA Reporting </NavLink>
          </div>

          <div className="navbar-collapse collapse navbar-responsive-collapse">

            <ul className="nav navbar-nav">

              <li className="dropdown">
                <a className="dropdown-toggle" href="#" data-toggle="dropdown">
                  Test runs <b className="caret" />
                </a>
                <ul className="dropdown-menu">
                  <li><NavLink to="/report/feature-testing-progress"> Feature Testing Progress </NavLink></li>
                  <li><NavLink to="/report/acceptance-testing-progress"> Acceptance Testing Progress </NavLink></li>
                  <li><NavLink to="/report/bvt-swarm">BVT and SWARM</NavLink></li>
                  <li><NavLink to="/report/tempest_metrics">Tempest</NavLink></li>
                  <li><NavLink to="/report/run-statuses"> Custom Test Runs Report </NavLink></li>
                  <li><NavLink to="/report/run-statuses-by-date"> Runs Report by Date </NavLink></li>
                  <li><NavLink to="/report/run-statuses-by-date-multichoice"> Runs Report by Date [multichoice]</NavLink></li>
                </ul>
              </li>

              <li className="dropdown">
                <a className="dropdown-toggle" href="#" data-toggle="dropdown">
                  Bugs <b className="caret" />
                </a>
                <ul className="dropdown-menu">
                  <li><NavLink to="/report/lp-failure-drivers-actual">[LP] Failure Drivers Actual</NavLink></li>
                  <li><NavLink to="/report/lp-failure-drivers-fixed">[LP] Failure Drivers Fixed</NavLink></li>
                  <li><NavLink to="/report/bugs-verification-progress">[LP] Bugs Verification Progress - overall </NavLink></li>
                  <li><NavLink to="/report/bugs-verification-progress-teams">[LP]
                  Bugs Verification Progress - by QA Teams </NavLink></li>
                  <li><NavLink to="/report/bug-trends">[LP] Bug Trends </NavLink></li>
                  <li><NavLink to="/report/reopened-bugs">[LP] Reopened Bugs</NavLink></li>
                  <li><NavLink to="/report/incomplete-bugs">[LP] Incomplete Bugs</NavLink></li>
                  <li><NavLink to="/report/regression-bugs">[LP] Regression Bugs</NavLink></li>
                  <li><NavLink to="/report/floating-bugs">[LP] Floating Bugs</NavLink></li>
                  <li role="separator" className="divider" />
                  <li><NavLink to="/report/jira-bugs-verification">[Jira] Bugs Verification Progress</NavLink></li>
                  <li><NavLink to="/report/jira-bugs-verification-version">[Jira] Bugs Verification Progress by Fix Version</NavLink></li>
                  <li><NavLink to="/report/jira-bugs-verification-teams">[Jira] Bugs Verification Progress by Teams</NavLink></li>
                  <li><NavLink to="/report/jira-failure-drivers">[Jira] Failure Drivers</NavLink></li>
                  <li><NavLink to="/report/jira-bug-trends">[Jira] Bug Trends</NavLink></li>
                  <li><NavLink to="/report/jira-reopened-bugs">[Jira] Reopened Bugs</NavLink></li>
                  <li><NavLink to="/report/jira-bugs-regression">[Jira] Regression Bugs</NavLink></li>
                  <li><NavLink to="/report/jira-failure-drivers_deprecation">[Jira] Failure Drivers (deprecation)</NavLink></li>
                </ul>
              </li>
              <li className="dropdown">
                <a className="dropdown-toggle" href="#" data-toggle="dropdown">
                  Test cases <b className="caret" />
                </a>
                <ul className="dropdown-menu">
                  <li><NavLink to="/report/automation-progress">Automation Progress</NavLink></li>
                  <li><NavLink to="/report/case-complexities">Case Complexities</NavLink></li>
                  <li><NavLink to="/report/cases">Custom Test Cases Report</NavLink></li>
                  <li><NavLink to="/report/adoption-progress">Adoption Progress</NavLink></li>
                  <li><NavLink to="/report/suites">Suites</NavLink></li>
                </ul>
              </li>
            </ul>
            <ul className="nav navbar-nav navbar-right">
              <li>
                <p className="navbar-text">{this.state.email}</p>
              </li>
              <li>
                <NavLink to="/logout">
                  <i className="fa fa-sign-out" /> Sign out
                </NavLink>
              </li>
            </ul>
          </div>
        </div>
      </div>
    );
  }
}
