
export const STATUS_FIX_COMMITTED = 'Fix Committed';
export const STATUS_FIX_RELEASED = 'Fix Released';

export const FAKE_STATUS_DEV_TO_VERIFY = 'Dev-to-verify';
export const FAKE_STATUS_OPEN = 'Open';

export const IMPORTANCE_CRITICAL = 'Critical';
export const IMPORTANCE_HIGH = 'High';

export const FIXED_BUG_STATUSES = [
  STATUS_FIX_COMMITTED,
  STATUS_FIX_RELEASED,
  'Invalid',
  'Won\'t Fix',
];

export const OPEN_BUG_STATUSES = [
  'Confirmed',
  'Incomplete',
  'Triaged',
  'In Progress',
];

export const BUG_STATUSES = [
  'New',
  ...OPEN_BUG_STATUSES,
  ...FIXED_BUG_STATUSES,
  'Opinion',
];

export const BLOCKER_BUG_TAGS = [
  'swarm-blocker',
  'blocker-for-qa',
];

export const LAUNCHPAD_QATEAM_MAP = {
  0: 'Fuel QA',
  1: 'MOS QA',
  2: 'Telco QA',
  3: 'PCE QA',
  4: 'Performance QA',
  5: 'Maintenance QA',
  // 6: 'Docs',
  7: 'Infra',
  8: 'Devs',
  // 9: 'Unknown',
};

export const TeamsURIParams = {
  'Fuel QA': [
    'fuel-qa',
    'fuel-configdb',
    'fuel-other',
    'fuel-sustaining',
    'fuel-toolbox',
    'fuel-ui',
    'fuel-customer-enablement',
    'fuel-octane-team',
    'fuel-opnfv-team',
    'workloads',
    'networking',
  ],
  'MOS QA': [
    'mos-ceilometer',
    'mos-ceph',
    'mos-cinder',
    'mos-glance',
    'mos-heat',
    'mos-horizon',
    'mos-ironic',
    'mos-kernel-networking',
    'mos-kernel-storage',
    'mos-kernel-virt',
    'mos-keystone',
    'mos-linux',
    'mos-murano',
    'mos-neutron',
    'mos-nova',
    'mos-oslo',
    'mos-packaging',
    'mos-puppet',
    'mos-sahara',
    'mos-scale',
    'mos-swift',
    'mos-qa',
  ],
  'Telco QA': ['fuel-qa-telco'],
  'PCE QA': [
    'fuel-customer-enablement',
    'fuel-octane-team',
    'fuel-opnfv-team',
    'fuel-plugins',
    'contrail-plugin',
    'dvs-plugin',
    'fuel-partner-engineering',
  ],
  'Performance QA': ['scale', 'performance-qa'],
  'Maintenance QA': ['mos-maintenance', 'maintenance-qa'],
  Docs: ['doc-team'],
  Infra: [
    'fuel-build',
    'fuel-ci',
    'fuel-devops',
    'fuel-infra-apps',
  ],
  Devs: ['devs-to-verify'],
  Unknown: ['unknown'],
};

const relatedTags = ['system-tests', 'fuel-devops', 'area-build', 'area-ci', 'area-devops', 'area-infra-apps', 'area-qa'];

export const LP_URI = {
  prod: {
    exclude_tags: [...relatedTags, 'covered-by-bp', 'feature', 'need-bp', 'non-release', 'tech-debt', 'enhancement', 'devops', 'docs', 'experimental'],
    tags: [],
    area_tags: [],
  },
  rel: {
    exclude_tags: [],
    tags: relatedTags,
    area_tags: [],
  },
  intqa: {
    exclude_tags: [],
    tags: ['area-qa', 'fuel-devops', 'system-tests'],
    area_tags: [],
  },
};

export const LP_MILESTONE_IN_FOCUS = '9.1';

export const VERIFICATION_PROGRESS_RESOURCE = '/api/v1.0/lp/verification_progress';
export const LAST_SYNC_INFO_URL = '/api/v1.0/lp/sync/last';
export const REOPENED_BUGS_URL = '/api/v1.0/lp/reopened_bugs';
export const INCOMPLETE_BUGS_URL = '/api/v1.0/lp/incomplete_bugs';
export const REGRESSION_BUGS_URL = '/api/v1.0/lp/regression_bugs';
export const FLOATING_BUGS_URL = '/api/v1.0/lp/floating_issues';
