/**
 * Created by farhad on 22.04.16.
 */

export const TESTRAIL_BASE_URL = 'https://mirantis.testrail.com';

export const LAST_SYNC_INFO_URL = '/api/v1.0/testrail/sync/last';
export const RUNS_STATUSES_RESOURCE = '/api/v1.0/testrail/run_statuses';
export const CASES_LIST_RESOURCE = '/api/v1.0/testrail/cases';
export const AUTOMATION_PROGRESS_RESOURCE = '/api/v1.0/testrail/automation_progress';
export const ADOPTION_PROGRESS_RESOURCE = '/api/v1.0/testrail/adoption_progress';
export const SUITE_PROGRESS_RESOURCE = '/api/v1.0/testrail/suite_progress';


export const DEFAULT_TEAM_NAME = 'Unknown';

export const Complexity = {
  SMOKE: 1,
  CORE: 2,
  ADVANCED: 3,
};

export const Statuses = {
  PASSED: 'passed',
  FAILED: 'failed',
  PROD_FAILED: 'prod_failed',
  TEST_FAILED: 'test_failed',
  INFRA_FAILED: 'infra_failed',
  SKIPPED: 'skipped',
  OTHER: 'other',
  BLOCKED: 'blocked',
  IN_PROGRESS: 'in_progress',
  FIXED: 'fixed',
  REGRESSION: 'regression',
  UNTESTED: 'untested',
};


export const CaseTypes = {
  AUTOMATED_ID: 1,
  MANUAL_ID: 7,
  AUTOMATION_IN_PROGRESS_ID: 8,
};

export const StatusOrder = [
  'other', 'regression', 'prod_failed', 'failed',
  'test_failed', 'infra_failed', 'in_progress', 'untested',
  'fixed', 'blocked', 'skipped', 'passed',
];

export const statusDomain = [
  'blocked', 'failed', 'fixed', 'in_progress',
  'infra_failed', 'other', 'passed', 'prod_failed',
  'regression', 'skipped', 'test_failed', 'untested',
];

export const statusRange = [
  '#8497B0', '#E6B9B8', '#548235', '#4472C4',
  '#FF3399', '#806000', 'green', '#FF0000',
  '#1F4E78', '#984807', '#FF7C80', '#595959',
];

export const FIELD_MANUAL = 'manual';
export const FIELD_AUTOMATION_IN_PROGRESS = 'in_progress';
export const FIELD_AUTOMATED = 'automated';
export const FIELD_PCT_AUTOMATED = 'pct_automated';
export const FIELD_WILL_NOT_AUTOMATE = 'not_automate';
export const FIELD_CI_INTEGRATION = 'ci_integration';
