/**
 * Created by farhad on 07.06.16.
 */
import moment from 'moment';
import { CALL_API } from 'redux-api-middleware';

const makeConstTypes = prefix => [`${prefix}_REQUEST`, `${prefix}_SUCCESS`, `${prefix}_FAILURE`];

export const SELECT_RELEASE = 'DASH_SELECT_RELEASE';

export function selectRelease(release) {
  return {
    type: SELECT_RELEASE,
    release,
  };
}

export function loadDefaultRelease() {
  return dispatch => fetch('/api/v1.0/dashboard', { credentials: 'same-origin' })
    .then(res => res.json())
    .then(data => dispatch({ type: SELECT_RELEASE, release: data.name }));
}

export const BUGS_VERIFICATION_SUMMARY_TYPES = makeConstTypes('BUGS_VERIFICATION_SUMMARY');

export function fetchBugsVerificationSummary(milestone) {
  return {
    [CALL_API]: {
      endpoint: `/api/v1.0/lp/verification_progress/summary/${milestone}`,
      types: BUGS_VERIFICATION_SUMMARY_TYPES,
    },
  };
}

export const CASES_AUTOMATION_SUMMARY_TYPES = makeConstTypes('CASES_AUTOMATION_SUMMARY');

export function fetchCasesAutomationSummary(milestone) {
  return {
    [CALL_API]: {
      endpoint: `/api/v1.0/testrail/automation_progress/summary/${milestone}`,
      types: CASES_AUTOMATION_SUMMARY_TYPES,
    },
  };
}

export const FEATURE_TESTING_SUMMARY_TYPES = makeConstTypes('FEATURE_TESTING_SUMMARY');

export function fetchFeatureTestingSummary(milestone) {
  return {
    [CALL_API]: {
      endpoint: `/api/v1.0/feature_testing_progress/summary/${milestone}`,
      types: FEATURE_TESTING_SUMMARY_TYPES,
    },
  };
}


export const ACCEPTANCE_SUMMARY_TYPES = makeConstTypes('ACCEPTANCE_SUMMARY');

export function fetchAcceptanceSummary(milestone) {
  return {
    [CALL_API]: {
      endpoint: '/api/v1.0/testrail/acceptance_swarm_tempest?' +
        `milestone=${encodeURIComponent(milestone)}`,
      types: ACCEPTANCE_SUMMARY_TYPES,
    },
  };
}

export const SWARM_TEMPEST_SUMMARY_TYPES = makeConstTypes('SWARM_TEMPEST_SUMMARY');

export function fetchSwarmTempestSummary(milestone) {

  return {
    [CALL_API]: {
      endpoint: '/api/v1.0/testrail/swam_tempest_summary?' +
        `milestone=${encodeURIComponent(milestone)}`,
      types: SWARM_TEMPEST_SUMMARY_TYPES,
    },
  };
}
