import React from 'react';
import * as BS from 'react-bootstrap';


const Widget = (props) => {
  const { title, expandUrl, panelProps, widgetLabel, widgetTitle, ...restProps } = props;
  const headerCmp = (
    <div style={{ fontSize: 18, padding: '1px 5px 0px 5px' }}>
      <div>
        <div style={{ minWidth: 50, float: 'right', paddingTop: 3 }}>
          <a href={expandUrl}
            target="_blank"
            style={{ color: 'white' }}
            title="open full report in new tab"
          >
            <i className="fa fa-external-link fa-pull-right" />
          </a>
        </div>
        <div className="widgetDraggableArea" style={{ cursor: 'move' }}>
          <span>{title}</span>
        </div>
      </div>
    </div>
  );
  return (
    <BS.Panel
      className="widget no-heading-padding"
      header={headerCmp}
      style={{
        height: '100%',
        overflow: 'hidden',
      }}
      {...panelProps}
    >
      <div fill className="widget-body" style={{ height: '100%', padding: '0px 5px' }} {...restProps}>
        <h2 style={{ margin: '1px 0px 10px', fontWeight: 'bold' }}>{widgetTitle}
          <small> {widgetLabel}</small></h2>
        {props.children}
      </div>
    </BS.Panel>
  );
};

Widget.propTypes = {
  widgetLabel: React.PropTypes.string,
  title: React.PropTypes.string,
};

export default Widget;
