/**
 * Created by farhad on 07.06.16.
 */

import { combineReducers } from 'redux';
import * as ActionTypes from './actions';

function release(state = '9.1', action) {
  if (action.type == ActionTypes.SELECT_RELEASE) {
    return action.release;
  }
  return state;
}

function makeSimpleReducer(actionTypes) {
  const [requestType, successType, failureType] = actionTypes;

  return function (state = { isFetching: false, data: null }, action) {
    switch (action.type) {
      case requestType:
        return { ...state, isFetching: true };
      case successType:
        return { ...state, isFetching: false, data: action.payload };
      case failureType:
        return { ...state, error: action.error };
      default:
        return state;
    }
  };
}

const bugsVerificationSummary = makeSimpleReducer(ActionTypes.BUGS_VERIFICATION_SUMMARY_TYPES);
const casesAutomationProgressSummary = makeSimpleReducer(ActionTypes.CASES_AUTOMATION_SUMMARY_TYPES);
const featureTestingSummary = makeSimpleReducer(ActionTypes.FEATURE_TESTING_SUMMARY_TYPES);
const acceptanceSummary = makeSimpleReducer(ActionTypes.ACCEPTANCE_SUMMARY_TYPES);
const bvtSwarmTempestSummary = makeSimpleReducer(ActionTypes.SWARM_TEMPEST_SUMMARY_TYPES);


export const dashboard = combineReducers({
  release,
  acceptanceSummary,
  bvtSwarmTempestSummary,
  bugsVerificationSummary,
  casesAutomationProgressSummary,
  featureTestingSummary,
});
