import 'bootstrap-less';
import 'bootstrap-material-design';
import ES6Promise from 'es6-promise';
import 'isomorphic-fetch';
import $ from 'expose?$!jquery';
import moment from 'expose?moment!moment';
import React from 'react';
import { render } from 'react-dom';
import { browserHistory } from 'react-router';

import './less/main.less';
import Root from './containers/Root';
import configureStore from './store';
import { loadDefaultRelease } from './dashboard/actions';

ES6Promise.polyfill();
const store = configureStore();
store.dispatch(loadDefaultRelease());

if (process.env.NODE_ENV !== 'production') {
  window.store = store;
}

render(
  <Root store={store} history={browserHistory} />,
  document.getElementById('app-block')
);


$(document).ajaxError((event, jqxhr) => {
  if (jqxhr.status === 401) {
    window.location = '/login';
  }
});

$(function () {
  $(window).scroll(() => {
    if ($(this).scrollTop() > 10) {
      $('.navbar-fixed-top').fadeOut();
    } else {
      $('.navbar-fixed-top').fadeIn();
    }
  });
});

$.material.init();
