import React, { Component, PropTypes } from 'react';
import moment from 'moment';

const propTypes = {
  module: PropTypes.string.isRequired,
};


class LastSyncInfo extends Component {

  constructor(props) {
    super(props);
    this.state = {
      lastSyncDate: 'fetching... ',
    };
  }

  componentDidMount() {
    let url;
    if (this.props.module === 'lp') {
      url = '/api/v1.0/lp/sync/last';
    } else if (this.props.module === 'tr') {
      url = '/api/v1.0/testrail/sync/last';
    } else if (this.props.module === 'jira') {
      url = '/api/v1.0/jira/sync/last';
    }
    $.get(url)
      .done((info) => {
        if (info) {
          const date = new Date(info.started);
          this.setState({ lastSyncDate: moment(date).fromNow() });
        } else {
          this.setState({ lastSyncDate: '[unknown]' });
        }
      })
      .fail(() => { this.setState({ lastSyncDate: 'cannot fetch data' }); });
  }

  render() {
    return (
      <div>
        {`Updated ${this.state.lastSyncDate}`}
      </div>
    );
  }
}

LastSyncInfo.propTypes = propTypes;

export default LastSyncInfo;
