import React from 'react';
import _ from 'lodash';
import { Popover, OverlayTrigger } from 'react-bootstrap';

const propTypes = {
  params: React.PropTypes.shape({
    colDef: React.PropTypes.shape({
      headerName: React.PropTypes.string,
    }),
    data: React.PropTypes.any,
    value: React.PropTypes.number,
  }),
};

const PopoverCell = (props) => {
  const link = (bugId, index) =>
    <p key={index}>
      <a target="_blank" rel="noreferrer noopener" href={`http://launchpad.net/bugs/${bugId}`} >
        {bugId}
      </a>
    </p>;

  const listOfLinks = bugList => (
        bugList.map((bugId, index) => link(bugId, index))
    );

  const popoverStyle = {
    background: '#eeeeee',
    border: '1px solid #ccc',
    borderRadius: '3px',
    color: 'black',
  };

  const customPopover = (
    <Popover id="popover-trigger-click-root-close" title="Bug Links" style={popoverStyle}>
      {props.params.data[_.snakeCase(props.params.colDef.headerName)].bugIds
        ? listOfLinks(props.params.data[_.snakeCase(props.params.colDef.headerName)].bugIds)
        : null}
    </Popover>
  );

  return (
    <OverlayTrigger rootClose trigger="click" placement="top" overlay={customPopover}>
      <a>{ props.params.value }</a>
    </OverlayTrigger>
  );
};

PopoverCell.propTypes = propTypes;
export default PopoverCell;
