/**
 * Created by farhad on 20.02.16.
 */
import React from 'react';
import { Route, IndexRoute } from 'react-router';

import App from './components/App';
import Logout from './components/Logout';
import Dashboard from './dashboard/containers/Dashboard';
import NotImplemented from './components/NotImplemented';
import NotFoundError from './components/NotFoundError';

import RunStatusesReport from './reports/RunStatuses';
import AutomationProgressReport from './reports/AutomationProgress';
import CasesReport from './reports/Cases';
import CaseComplexitiesReport from './reports/CaseComplexities';
import BugsVerificationProgress from './reports/BugsVerificationProgress';
import BvtAndSwarmMetrics from './reports/BvtAndSwarmMetrics';
import FeatureTestingProgress from './reports/FeatureTestingProgress';
import TempestMetrics from './reports/TempestMetrics';
import BugTrends from './reports/BugTrends';
import BugsVerificationProgressTeams from './reports/BugsVerificationProgressTeams';
import DiagnosticPage from './reports/DiagnosticPage';
import ReopenedBugsReport from './reports/ReopenedBugsReport';
import IncompleteBugsReport from './reports/IncompleteBugsReport';
import RegressionBugsReport from './reports/RegressionBugsReport';
import AdminArea from './admin/Index';
import AcceptanceTestingProgress from './reports/AcceptanceTestingProgress';
import AdoptionProgress from './reports/AdoptionProgress';
import TCPMCPBugsVerificationProgressVersion from './reports/TCPMCPBugsVerificationProgress';
import TCPMCPBugsVerificationProgressTeams from './reports/TCPMCPBugsVerificationProgressTeams';
import FDrivers from './reports/JiraFailureDrivers';
import JiraBugTrends from './reports/JiraBugTrends';
import JiraReopenedBugs from './reports/JiraReopenedBugs';
import JiraBugsVerification from './reports/JiraBugs';
import JiraRegression from './reports/JiraRegression';
import FloatingBugsReport from './reports/FloatingBugsReport';
import RunStatusesByDate from './reports/RunStatusesByDate';
import SuiteProgress from './reports/SuiteProgress';
import FailureDriversJira from './reports/FailureDriversJira';
import LpFailureDriversActual from './reports/LpFailureDriversActual';
import LpFailureDriversFixed from './reports/LpFailureDriversFixed';
import RunStatusesByDateMultiSelect from './reports/RunStatusesByDateMultiSelect';


const routes = (
  <Route path="/" component={App}>
    <IndexRoute component={Dashboard} />
    <Route path="dashboard:release" component={Dashboard} />
    <Route path="logout" component={Logout} />
    <Route path="diag" component={DiagnosticPage} />
    <Route path="admin" component={AdminArea} />
    <Route path="report">
      <Route path="run-statuses" component={RunStatusesReport} />
      <Route path="cases" component={CasesReport} />
      <Route path="automation-progress" component={AutomationProgressReport} />
      <Route path="case-complexities" component={CaseComplexitiesReport} />
      <Route path="bugs-verification-progress" component={BugsVerificationProgress} />
      <Route path="bug-trends" component={BugTrends} />
      <Route path="bvt-swarm" component={BvtAndSwarmMetrics} />
      <Route path="feature-testing-progress" component={FeatureTestingProgress} />
      <Route path="tempest_metrics" component={TempestMetrics} />
      <Route path="bugs-verification-progress-teams" component={BugsVerificationProgressTeams} />
      <Route path="reopened-bugs" component={ReopenedBugsReport} />
      <Route path="incomplete-bugs" component={IncompleteBugsReport} />
      <Route path="regression-bugs" component={RegressionBugsReport} />
      <Route path="acceptance-testing-progress" component={AcceptanceTestingProgress} />
      <Route path="adoption-progress" component={AdoptionProgress} />
      <Route path="jira-bugs-verification-version" component={TCPMCPBugsVerificationProgressVersion} />
      <Route path="jira-bugs-verification-teams" component={TCPMCPBugsVerificationProgressTeams} />
      <Route path="jira-failure-drivers_deprecation" component={FDrivers} />
      <Route path="jira-bug-trends" component={JiraBugTrends} />
      <Route path="jira-reopened-bugs" component={JiraReopenedBugs} />
      <Route path="jira-bugs-verification" component={JiraBugsVerification} />
      <Route path="jira-bugs-regression" component={JiraRegression} />
      <Route path="floating-bugs" component={FloatingBugsReport} />
      <Route path="run-statuses-by-date" component={RunStatusesByDate} />
      <Route path="suites" component={SuiteProgress} />
      <Route path="jira-failure-drivers" component={FailureDriversJira} />
      <Route path="lp-failure-drivers-actual" component={LpFailureDriversActual} />
      <Route path="lp-failure-drivers-fixed" component={LpFailureDriversFixed} />
      <Route path="run-statuses-by-date-multichoice" component={RunStatusesByDateMultiSelect} />
    </Route>
    <Route path="stub/:pageName" component={NotImplemented} />
    <Route path="*" component={NotFoundError} />
  </Route>
);

export default routes;
