from qareporting.integration.launchpad.consts import (
    STATUS_INCOMPLETE)
from qareporting.integration.launchpad.models import (
    BugTaskHistory)
from qareporting.resources.incomplete_bugs_report import HALF_YEAR_BACK
from qareporting.utils import dt_now


def get_incomplete_bugs(milestone_name):
    incomplete_bugs = BugTaskHistory.objects(
        version_begin__gt=HALF_YEAR_BACK,
        version_end__gt=dt_now(),
        status=STATUS_INCOMPLETE,
        milestone=milestone_name,
    ).as_pymongo().only('bug_id')

    result = dict()

    for bug in incomplete_bugs:
        reporter = BugTaskHistory.objects(
            bug_id=bug['bug_id']
        ).order_by('version_begin').first()
        result[bug['bug_id']] = reporter.status_change_person

    return result
