import datetime
import logging

import pytz
from flask_script import Command
from flask_script import Option


from qareporting.integration.models import Iteration


log = logging.getLogger(__name__)


def make_range(start_date, delta, count):
    date = start_date
    for i in range(count):
        end = date + delta
        yield (i + 1, date, end)
        date = end


week = datetime.timedelta(days=7)
week3 = week * 3

config = {
    '9.0': make_range(
        datetime.datetime(2015, 10, 1).replace(tzinfo=pytz.utc), week3, 28
    ),
    '9.1': make_range(
        datetime.datetime(2015, 10, 1).replace(tzinfo=pytz.utc), week3, 28
    ),
    '9.2': make_range(
        datetime.datetime(2015, 10, 1).replace(tzinfo=pytz.utc), week3, 28
    ),
    '10.0': make_range(
        datetime.datetime(2016, 6, 30).replace(tzinfo=pytz.utc), week3, 14
    ),
    'MK22': make_range(
        datetime.datetime(2015, 10, 1).replace(tzinfo=pytz.utc), week3, 28
    ),
    'MK20': make_range(
        datetime.datetime(2015, 10, 1).replace(tzinfo=pytz.utc), week3, 28
    ),
    'MK30': make_range(
        datetime.datetime(2015, 10, 1).replace(tzinfo=pytz.utc), week3, 28
    ),
}


class MakeIterationsCommand(Command):

    def run(self):
        for milestone, iterations in config.items():
            for index, begin, end in iterations:
                try:
                    obj = Iteration.objects.get(
                        index=index, milestone=milestone)
                except Iteration.DoesNotExist:
                    obj = Iteration(milestone=milestone, index=index)

                obj.date_begin = begin
                obj.date_end = end
                obj.save()
