import logging

from flask_script import Command

from qareporting.integration.launchpad.models import Bug, LaunchpadProject
from qareporting.integration.launchpad.history_updater import (
    BugTaskHistoryUpdater)

log = logging.getLogger(__name__)


class UpdateBugTaskHistoryCommand(Command):

    def run(self):

        projects = tuple(LaunchpadProject.objects.all())

        query = Bug.objects.all().order_by('-id')
        cnt = query.count()

        for i, bug in enumerate(query, 1):
            updater = BugTaskHistoryUpdater(bug, projects=projects)
            updater.perform_update()

            if i % 100 == 0 or i == cnt:
                log.info('building history: %s/%s', i, cnt)

