PROJECTS = ('mos', 'fuel')

STATUS_NEW = 'New'
STATUS_INCOMPLETE = 'Incomplete'
STATUS_INVALID = 'Invalid'
STATUS_WONT_FIX = "Won't Fix"
STATUS_CONFIRMED = 'Confirmed'
STATUS_TRIAGED = 'Triaged'
STATUS_IN_PROGRESS = 'In Progress'
STATUS_FIX_COMMITTED = 'Fix Committed'
STATUS_FIX_RELEASED = 'Fix Released'
STATUS_OPINION = 'Opinion'
STATUS_EXPIRED = 'Expired'


ALL_STATUSES = [
    STATUS_NEW,
    STATUS_INCOMPLETE,
    STATUS_INVALID,
    STATUS_WONT_FIX,
    STATUS_CONFIRMED,
    STATUS_TRIAGED,
    STATUS_IN_PROGRESS,
    STATUS_FIX_COMMITTED,
    STATUS_FIX_RELEASED,
    STATUS_OPINION,
    STATUS_EXPIRED,
]

OPEN_STATUSES = [
    STATUS_CONFIRMED,
    STATUS_INCOMPLETE,
    STATUS_TRIAGED,
    STATUS_IN_PROGRESS,
]

FIXED_STATUSES = [
    STATUS_FIX_RELEASED,
    STATUS_FIX_COMMITTED,
    STATUS_INVALID,
    STATUS_WONT_FIX,
]

IMPORTANCE_CRITICAL = 'Critical'
IMPORTANCE_HIGH = 'High'
IMPORTANCE_MEDIUM = 'Medium'
IMPORTANCE_LOW = 'Low'
IMPORTANCE_WISHLIST = 'Wishlist'
IMPORTANCE_UNDECIDED = 'Undecided'


# TODO: Move it to the database and setup auto updating
FOCUS_OF_DEVELOPMENT_HISTORY = {
    "fuel": [
        ["2014-02-27T15:56:40.894000+00:00", "fuel/4.1.x"],
        ["2014-03-13T12:43:06.323000+00:00", "fuel/4.1.x"],
        ["2014-05-19T11:44:06.025000+00:00", "fuel/5.0.x"],
        ["2014-05-29T14:59:26.903000+00:00", "fuel/5.0.x"],
        ["2014-08-22T15:33:26.275000+00:00", "fuel/5.1.x"],
        ["2014-09-23T13:33:40.021000+00:00", "fuel/5.1.x"],
        ["2014-09-23T22:01:04.883000+00:00", "fuel/6.0.x"],
        ["2014-12-30T14:06:34.233000+00:00", "fuel/6.0.x"],
        ["2014-12-30T15:46:16.407000+00:00", "fuel/6.1.x"],
        ["2015-06-15T18:03:30.616000+00:00", "fuel/6.1.x"],
        ["2015-06-15T20:07:28.558000+00:00", "fuel/7.0.x"],
        ["2015-09-09T12:00:38.140000+00:00", "fuel/7.0.x"],
        ["2015-09-10T11:59:10.052000+00:00", "fuel/8.0.x"],
        ["2015-12-23T12:40:25.298000+00:00", "fuel/8.0.x"],
        ["2015-12-24T15:13:28.395000+00:00", "fuel/mitaka"],
        ["2016-04-07T13:58:04.811000+00:00", "fuel/mitaka"],
        ["2016-04-08T08:40:30.436000+00:00", "fuel/newton"],
        ["2016-10-19T21:35:21.84000+00:00", "fuel/newton"],
        ["2016-11-03T10:47:13.520000+00:00", "fuel/ocata"],
        ["2017-01-20T16:28:0.755000+00:00", "fuel/ocata"],
    ],
    "mos": [
        ["2014-06-19T15:25:03.621000+00:00", "mos/5.1.x"],
        ["2014-09-22T23:46:09.926000+00:00", "mos/5.1.x"],
        ["2014-10-01T12:57:49.673000+00:00", "mos/6.0.x"],
        ["2015-01-21T13:54:57.272000+00:00", "mos/6.0.x"],
        ["2015-01-21T18:22:46.429000+00:00", "mos/6.1.x"],
        ["2015-06-11T13:42:50.318000+00:00", "mos/6.1.x"],
        ["2015-06-16T09:15:36.937000+00:00", "mos/7.0.x"],
        ["2015-09-08T14:04:49.882000+00:00", "mos/7.0.x"],
        ["2015-09-09T13:09:06.784000+00:00", "mos/8.0.x"],
        ["2016-04-05T07:18:16.515000+00:00", "mos/8.0.x"],
        ["2016-04-06T13:41:24.920000+00:00", "mos/9.x"],
        ["2016-04-12T09:49:57.587000+00:00", "mos/9.x"],
    ]
}


# If bug contains at least one tag from this list - it s considered
# as "Release - related" bug:
RELATED_BUGS_INCLUDE_TAGS = [
    'area-build',
    'area-ci',
    'area-devops',
    'area-infra-apps',
    'area-qa',
    'fuel-devops',
    'system-tests',
]

# If bug doesn't contain any tag from this list - it s considered
# as "Product-related customer-affecting" bug:
PRODUCT_BUGS_EXCLUDE_TAGS = RELATED_BUGS_INCLUDE_TAGS + [
    'covered-by-bp',
    'feature',
    'need-bp',
    'non-release',
    'tech-debt',
    'enhancement',
    'devops',
    'docs',
    'experimental',
]

INTERNALQA_BUGS_INCLUDE_TAGS = [
    'area-qa',
    'fuel-devops',
    'system-tests',
]


class MajorQATeams:

    # Our internal IDS of teams
    TEAM_FUEL_ID = 2  # Equals to testrail
    TEAM_MAINTENANCE_ID = 3  # Equals to testrail
    TEAM_MOS_ID = 4  # Equals to testrail
    TEAM_PLUGINS_ID = 5
    TEAM_PCE_ID = 6  # Equals to testrail
    TEAM_DOCS_ID = 7
    TEAM_CUSTOMER_ENABLEMENT_ID = 8
    TEAM_WORKLOADS_ID = 9
    TEAM_L23NETWORKING_ID = 10
    TEAM_INFRA_ID = 11
    TEAM_QA_ID = 12
    TEAM_UNKNOWN = 13

    # Mapping that used for match teams from lp-reports.
    CODES_IN_LP_REPORTS = {
        TEAM_FUEL_ID: 'Fuel',
        TEAM_MAINTENANCE_ID: 'Maintenance',
        TEAM_MOS_ID: 'MOS OpenStack',
        TEAM_PLUGINS_ID: 'Plugins',
        TEAM_PCE_ID: 'PCE',
        TEAM_DOCS_ID: 'Docs',
        TEAM_CUSTOMER_ENABLEMENT_ID: 'Customer-Enablement',
        TEAM_WORKLOADS_ID: 'Workloads',
        TEAM_L23NETWORKING_ID: 'L23Networking',
        TEAM_INFRA_ID: 'Infra',
        TEAM_QA_ID: 'QA',
        TEAM_UNKNOWN: 'Unknown',
    }

    # Now it equals to CODES_IN_LP_REPORTS, but it may change.
    # So we distinct this mappings.
    NAMES = dict(CODES_IN_LP_REPORTS)


FUEL_TEAM_AREA_TAGS = [
    'area-python',
    'area-ui',
    'area-library',
]

FAKE_TELCO_ID = 16

FUEL_TEAMS = (
    'doc-team',
    'fuel-build',
    'fuel-ci',
    'fuel-configdb',
    'fuel-devops',
    'fuel-octane-team',
    'fuel-opnfv-team',
    'fuel-other',
    'fuel-qa',
    'fuel-sustaining',
    'fuel-toolbox',
    'fuel-ui',
    'networking',
    'workloads',
)

PCE_TEAMS = (
    'dvs-plugin',
    'fuel-partner-engineering',
)
