import logging

from flask_script import Command
from flask_script import Option

from qareporting.integration.testrail.sync import TestRailSync


log = logging.getLogger(__name__)


class SyncTestRailCommand(Command):
    option_list = (
        Option('--fast',
               action='store_true',
               help='Fast sync'),
        Option('--projects',
               type=lambda x: [int(i) for i in x.split(',')],
               help='Project ids to sync'),
    )

    def run(self, fast=False, projects=None):
        sync = TestRailSync(
            fast_sync=fast,
            project_ids=projects,
        )
        sync.run()
