from flask import Blueprint
from flask import render_template, jsonify, request

from qareporting.auth.decorators import auth_required
from qareporting.integration.launchpad.models import Bug

pages = Blueprint('pages', __name__, url_prefix='')


@pages.route('/', defaults={'path': ''})
@pages.route('/<path:path>')
@auth_required
def index(path):
    return render_template('index.html')


@pages.route('/add_comment_to_bug', methods=['POST'])
def add_comment_to_bug():
    comment = request.form['comment']
    bug_id = request.form['bug_id']
    Bug.objects(id=bug_id).update_one(upsert=True,
                                      **{'user_comment': comment})
    return jsonify(True)


@pages.route('/add_eta_to_bug', methods=['POST'])
def add_eta_to_bug():
    eta = request.form['eta']
    bug_id = request.form['bug_id']
    Bug.objects(id=bug_id).update_one(upsert=True,
                                      **{'eta': eta})
    return jsonify(True)
