from flask_restful import fields
from flask_restful import marshal_with

from qareporting.ext import api
from qareporting.resources.base import BaseResource
from qareporting.auth.models import AuthUsers

auth_user_fields = {
    'id': fields.Integer,
    'email': fields.String,
    'name': fields.String,
    'family_name': fields.String,
    'given_name': fields.String,
    'picture': fields.String,
    'hd': fields.String,
    'verified_email': fields.Boolean,
}


class CurrentUserResource(BaseResource):
    @marshal_with(auth_user_fields)
    def get(self):
        return AuthUsers.get_current()


api.add_resource(CurrentUserResource, '/auth/user')
