from functools import wraps
import logging

from flask_restful import abort

from qareporting.auth.models import AuthUsers

log = logging.getLogger(__name__)


def auth_required(f):
    @wraps(f)
    def decorated(*args, **kwargs):
        user = AuthUsers.get_current()
        if not user:
            abort(401, code=401, message='Unauthorized access')
        return f(*args, **kwargs)
    return decorated
